;             This file is part of the ZRDX 0.42 project
;                     (C) 1998, Sergey Belyakov

;segment definitions for
;real mode rezident switchers for ZRDX DPMI host under VCPI
KernelBase = 4*1024*1024
SegRTNum = 0
Release = 1
SetupSeg MACRO Sz, DSz, S, PS
        Local _Sz
        ifdef RELEASE
          _Sz = (Sz + 15) and (not 0Fh)
        else
          _Sz = (DSz + 15) and (not 0Fh)
        endif
        SegSize&S = _Sz
        SegBase&S    = $ - XCurSegBase
        SegStart&S   = XCurSegBase
        XSegStart&S  = $
        SegStart&S&R = XCurSegBaseR
        SegEnd&S&R   = XCurSegBaseR+_Sz
        SegBaseR&S   = $ - XCurSegBaseR
        XCurSegBase  = XCurSegBase + _Sz
        XCurSegBaseR = XCurSegBaseR + _Sz
        ENDM
SetupRTSeg EQU SetupSeg
        XCurSegBase  = 0
        XCurSegBaseR = 0
VSegment MACRO Name, Sz, DSz
        ifdef RELEASE
          SegSize&Name = Sz
        else
          SegSize&Name = DSz
        endif
        Name&LC   = XCurSegBase
        Name&LC16 = XCurSegBaseR
        SegStart&Name&R = XCurSegBaseR
        ENDM
segment Text16  para use16 public 'CODE16'
ends Text16
segment Data16  para  use16 public 'DATA16'
ends Data16
segment RelocR0 use16 para public 'RELOCR'
        ;SegStartRelocR label byte
ends RelocR0
segment IText16 para use16 public 'IDATA'
ends IText16
segment IData16 para use16 public 'IDATA'
ends IData16
segment EText   para use32 public 'EXTENDER'
        ends
segment EData   para use32 public 'EXTENDER'
        ends
segment IEText  para use32 public 'LOADER'
        ends
segment IEData  para use32 public 'LOADER'
        ends
segment Text    para use32 public 'CODE'
ends Text
segment IText   para use32 public 'CODE'
ends IText
segment Data    para use32 public 'DATA'
ends Data
segment BSSX    para use32 public 'DATA'
        ends
segment Stock     para public 'XXXX'
;          db 40000 dup(?)
          ends
segment Stack16 para use16 stack 'STACK'
ends Stack16
comment &
EText16__0
Text16__459
Data16__0
RelocR0__32
IText16__1117
IData16__499
IEText16__528
EText__2289
EData__728
DBText__0
IEText__1507
IEData__330
Text__6295
IText__0
Data__326

Text16__536
Data16__0
RelocR0__78
IText16__2036
IData16__420
EText__2366
EData__725
DBText__0
IEText__1580
IEData__316
Text__6714
IText__0
Data__338
&
segment Text16  para use16 public 'CODE16'
        DPMIHOSTMaxLowData = XCurSegBaseR
        SetupRTSeg 536, 540, Text16, EText16
ends Text16
         ;RM data for IDPMI host
segment Data16  para  use16 public 'DATA16'
        SetupSeg 000, 0, Data16, Text16
ends Data16
         ;RM stack for IDMPI host
VSegment BSS16, 1000, 1000
segment RelocR0 use16 para public 'RELOCR'
        SetupSeg 78 , 82, RelocR0
ends RelocR0
        IDPMIDataSize = OffRStackEnd
segment IText16 para use16 public 'IDATA'
        SetupRTSeg 2056 , 2200, IText16, RelocR0
ends IText16
segment IData16 para use16 public 'IDATA'
        SetupSeg 420 , 600, IData16, IText16
ends IData16
segment EText   para use32 public 'EXTENDER'
        ExtenderStart = XCurSegBaseR
        TXCurSegBase  = XCurSegBase
        XCurSegBase   = 0
        SetupSeg 2366, 2400, EText, IData16
        ends
segment EData   para use32 public 'EXTENDER'
        SetupSeg 751, 862, EData, EText
        ends
VSegment EBSS, 200, 200
         ExtenderSize = XCurSegBase
         ExtenderFullSize = ExtenderSize+200
segment IEText  para use32 public 'LOADER'
        LoaderStart  = XCurSegBaseR
        TXCurSegBase = TXCurSegBase + XCurSegBase
        XCurSegBase = 0
        SetupSeg 1590, 2000, IEText, EData
        ends
segment IEData  para use32 public 'LOADER'
        SetupSeg 321, 500, IEData, IEText
        ends
        ROffLoaderEnd = XCurSegBaseR
        WinSize = (ROffLoaderEnd+0FFFh+200h) and not 0FFFh
        LoaderSize = XCurSegBase
        LoaderFullSize = LoaderSize+3000
VSegment IEBSS, 3008, 3008
        ;IDPMI host rezident code
segment Text    para use32 public 'CODE'
        Dummy320 = $       ;for force 32-bit offsets
        Dummy321 = $+1
        OffProtectedStart = XCurSegBaseR
        XCurSegBase = KernelBase
        SetupRTSeg 6760, 8000, Text, IEData
ends Text
segment IText   para use32 public 'CODE'
        SetupSeg 0000, 000, IText, Text
ends IText
segment Data    para use32 public 'DATA'
        SetupSeg 380, 600, Data, IText
ends Data
VSegment BSS, 9F00h, 9F00h
segment Stock   para  public 'XXXX'
          nStock = (OffLastInit-KernelBase) + WinSize+2000h + ROffRStackEnd - XCurSegBaseR
          db nStock dup(?)
          XCurSegBaseR = XCurSegBaseR + nStock
          ends
segment Stack16 para use16 stack 'STACK'
        StackSegBaseR = XCurSegBaseR
        DB  200h dup (?)
        ;DB (OffLastInit - OffFirstZeroInit+0FFFh) and 0FF000h dup(?)
ends Stack16
GROUP DGROUP16 Text16, Data16, IText16, IData16, RelocR0;, Reloc0, Stack16, RelocREnd, RelocEnd
GROUP EGroup EText, Edata
GROUP LGROUP IEData, IEText
GROUP DGROUP  Text, Data
LastRelocR = 0
LastReloc  = 0
CurRTNum   = 0
_RRTEntryes = 0

